#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "JZConfig.h"
#import "JZPayInfo.h"
#import "JZRoleInfo.h"

//SDK基本定义
#define GAME_MODEL @"JZSDK"
#define SDK_VERSION_CODE @"112"
#define SDK_VERSION_NAME @"1.1.2"

//配置参数的KEY
#define KEY_APP_ID @"KEY_APP_ID"
#define KEY_APP_KEY @"KEY_APP_KEY"

//消息通知事件Key
#define KEY_EVENT_CODE @"KEY_EVENT_CODE"
#define KEY_DATA @"KEY_DATA"

//消息通知数据Key
#define EXTRA_USER @"EXTRA_USER"
#define EXTRA_ERROR_MESSAGE @"EXTRA_ERROR_MESSAGE"
#define EXTRA_OUT_ORDER_ID @"EXTRA_OUT_ORDER_ID"

//消息通知事件码定义
typedef NS_ENUM(NSInteger,SDK_EVENT_CODE) {
    JZ_LOGIN_SUCCESS = 1,
    JZ_LOGIN_FAILED = 2,
    JZ_PAY_SUCCESS = 3,
    JZ_PAY_CANCEL = 4,
    JZ_PAY_FAILED = 5,
    JZ_SWITCH_SMALLACCOUNT = 6,
    JZ_SWITCH_ACCOUNT = 7,
    JZ_LOGINOUT_SUCCESS = 8
};

@interface JZSDK : NSObject

// 配置SDK参数
+(void)init:(JZConfig*)config observer:(id)observer eventHandler:(SEL)aSelector;
// 进入登录流程
+(void)login;
// 清除本地保存的用户信息，下次进入游戏不会自动登录
+(void)loginOut;
// 进入支付流程
+(void)payWithPayInfo:(JZPayInfo *)model;
// 提交角色信息
+(void)sendRoleInfo:(JZRoleInfo *)roleInfo;

+(UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(UIWindow *)window;

+(void)applicationWillEnterForeground:(UIApplication *)application;

+(void)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation;

+(void)application:(UIApplication *)application openURL:(NSURL *)url options:(NSDictionary<NSString*, id> *)options;

+(BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void (^)(NSArray<id<UIUserActivityRestoring>> * _Nullable))restorationHandler;


/// 废弃方法 后期将会移除

+(void)onOpenUrl:(NSURL *)url DEPRECATED_MSG_ATTRIBUTE("请使用application:(UIApplication *)application openURL:(NSURL *)url options:(NSDictionary<NSString*, id> *)options代替");

+(void)onEnterForeground:(UIApplication *)application DEPRECATED_MSG_ATTRIBUTE("请使用applicationWillEnterForeground代替");

+(void)applicationDidBecomeActive:(UIApplication *)application DEPRECATED_MSG_ATTRIBUTE("此方法不在使用");

/// 废弃方法 后期将会移除

@end
