#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "JZUConfig.h"
#import "JZUPayInfo.h"
#import "JZURoleInfo.h"

//SDK基本定义
#define USDK_VERSION_CODE @"106"
#define USDK_VERSION_NAME @"1.0.6"

//消息通知事件Key
#define KEY_EVENT_CODE @"KEY_EVENT_CODE"
#define KEY_DATA @"KEY_DATA"

//消息通知数据Key
#define EXTRA_USER @"EXTRA_USER"
#define EXTRA_ERROR_MESSAGE @"EXTRA_ERROR_MESSAGE"
#define EXTRA_OUT_ORDER_ID @"EXTRA_OUT_ORDER_ID"

//消息通知事件码定义
typedef NS_ENUM(NSInteger,JZU_EVENT_CODE) {
    JZU_LOGIN_SUCCESS = 1, //登录成功
    JZU_LOGIN_FAILED = 2,  //登录失败
    JZU_PAY_SUCCESS = 3,  //支付成功
    JZU_PAY_FAILED = 4,  //支付失败
    JZU_PAY_CANCEL = 5,  //支付取消
    JZU_SWITCH_SUCCESS = 6,  //切换账号成功
    JZU_LOGOUT_SUCCESS = 7,  //退出登录成功
    JZU_EXIT_SUCCESS = 8  //退出游戏
};

@interface JZUSDK : NSObject

//初始化配置SDK参数
+(void)jzInit:(JZUConfig *)sdkConfig observer:(id)observer eventCallBack:(SEL)aSelector initBlock:(void(^)())initBlock;

//登录
+(void)jzLogin;

//支付
+(void)jzPay:(JZUPayInfo *)payInfo;

//提交角色信息，<创建角色>和<进入游戏>和<角色升级等角色信息变化>时都要上传
+(void)jzSendRoleInfo:(JZURoleInfo *)gameInfo;

//退出登录
+(void)jzLogout;

//退出游戏
+(void)jzExit:(JZURoleInfo *)gameInfo;



//AppDelegate相关回调,所有方法必须接入

+ (void)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions;

+ (void)applicationWillResignActive:(UIApplication *)application;

+ (void)applicationDidEnterBackground:(UIApplication *)application;

+ (void)applicationWillEnterForeground:(UIApplication *)application;

+ (void)applicationDidBecomeActive:(UIApplication *)application;

+ (void)applicationWillTerminate:(UIApplication *)application;

+(BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void(^)(NSArray<id<UIUserActivityRestoring>> * __nullable restorableObjects))restorationHandler;

+ (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken;

+ (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error;

+ (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(nullable UIWindow *)window;

+ (void)application:(UIApplication *)application handleOpenURL:(NSURL *)url;

+ (void)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation;

+ (void)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString*, id> *)options;

@end
